"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request");
var RecimeLogger = /** @class */ (function () {
    function RecimeLogger(bot) {
        this.bot = bot;
    }
    RecimeLogger.prototype.incoming = function (body) {
        this.sendRequest({
            direction: "in",
            platform: this.platform,
            res: body
        });
    };
    RecimeLogger.prototype.outgoing = function (reqData, body) {
        this.sendRequest({
            direction: "out",
            platform: this.platform,
            req: reqData,
            res: body
        });
    };
    RecimeLogger.prototype.sendRequest = function (body) {
        var _this = this;
        return new Promise(function (resolve) {
            request({
                uri: "https://analytics-api.recime.io/v1/bots/" + _this.bot.id,
                method: 'POST',
                json: true,
                body: body,
                headers: {
                    authorization: "Token " + _this.bot.config.SYSTEM_RECIME_API_KEY,
                    'user-agent': 'recime.io/1.0 bot'
                }
            }, function (err) {
                if (err) {
                    console.error("Analytics:", err);
                }
                resolve();
            });
        });
    };
    return RecimeLogger;
}());
exports.RecimeLogger = RecimeLogger;
var BotFrameworkLogger = /** @class */ (function (_super) {
    __extends(BotFrameworkLogger, _super);
    function BotFrameworkLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(BotFrameworkLogger.prototype, "platform", {
        get: function () {
            return "bot-framework";
        },
        enumerable: true,
        configurable: true
    });
    return BotFrameworkLogger;
}(RecimeLogger));
exports.BotFrameworkLogger = BotFrameworkLogger;
var FacebookLogger = /** @class */ (function (_super) {
    __extends(FacebookLogger, _super);
    function FacebookLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(FacebookLogger.prototype, "platform", {
        get: function () { return 'facebook'; },
        enumerable: true,
        configurable: true
    });
    return FacebookLogger;
}(RecimeLogger));
exports.FacebookLogger = FacebookLogger;
var TelegramLogger = /** @class */ (function (_super) {
    __extends(TelegramLogger, _super);
    function TelegramLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(TelegramLogger.prototype, "platform", {
        get: function () { return 'telegram'; },
        enumerable: true,
        configurable: true
    });
    return TelegramLogger;
}(RecimeLogger));
exports.TelegramLogger = TelegramLogger;
var SlackLogger = /** @class */ (function (_super) {
    __extends(SlackLogger, _super);
    function SlackLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(SlackLogger.prototype, "platform", {
        get: function () { return 'slack'; },
        enumerable: true,
        configurable: true
    });
    return SlackLogger;
}(RecimeLogger));
exports.SlackLogger = SlackLogger;
var SendBirdLogger = /** @class */ (function (_super) {
    __extends(SendBirdLogger, _super);
    function SendBirdLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(SendBirdLogger.prototype, "platform", {
        get: function () { return 'sendbird'; },
        enumerable: true,
        configurable: true
    });
    return SendBirdLogger;
}(RecimeLogger));
exports.SendBirdLogger = SendBirdLogger;
var TwilioLogger = /** @class */ (function (_super) {
    __extends(TwilioLogger, _super);
    function TwilioLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(TwilioLogger.prototype, "platform", {
        get: function () { return 'twilio'; },
        enumerable: true,
        configurable: true
    });
    return TwilioLogger;
}(RecimeLogger));
exports.TwilioLogger = TwilioLogger;
var ViberLogger = /** @class */ (function (_super) {
    __extends(ViberLogger, _super);
    function ViberLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ViberLogger.prototype, "platform", {
        get: function () { return 'viber'; },
        enumerable: true,
        configurable: true
    });
    return ViberLogger;
}(RecimeLogger));
exports.ViberLogger = ViberLogger;
var WeChatLogger = /** @class */ (function (_super) {
    __extends(WeChatLogger, _super);
    function WeChatLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(WeChatLogger.prototype, "platform", {
        get: function () { return 'wechat'; },
        enumerable: true,
        configurable: true
    });
    return WeChatLogger;
}(RecimeLogger));
exports.WeChatLogger = WeChatLogger;
var WebLogger = /** @class */ (function (_super) {
    __extends(WebLogger, _super);
    function WebLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(WebLogger.prototype, "platform", {
        get: function () { return 'web'; },
        enumerable: true,
        configurable: true
    });
    return WebLogger;
}(RecimeLogger));
exports.WebLogger = WebLogger;
